{% import 'arty_basic_node/cmake_header_macro.jinja' as header_macros %}
{{ header_macros.generate_do_not_edit(generation_date, the_arquetype, archetype.version) }}

cmake_minimum_required(VERSION 3.8)

project({{ project.name }})

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# Common dependencies used in the template
find_package(ament_cmake REQUIRED)
find_package(ament_cmake_ros REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(pluginlib REQUIRED)
{% if lifecycle is defined and lifecycle %}
find_package(rclcpp_lifecycle REQUIRED)
{% endif %}

# User's dependencies from manifest
{% for dependency in dependencies %}
find_package({{ dependency }} REQUIRED)
{% endfor %}

include_directories(
  include
  include/${PROJECT_NAME}
)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

# Source files
set(SOURCES src/node_gen.cpp)

# Add internal source files
file(GLOB INTERNAL_SOURCES "src/internal/*.cpp")

add_library(${PROJECT_NAME}_component SHARED ${SOURCES} ${INTERNAL_SOURCES})
ament_target_dependencies(
	${PROJECT_NAME}_component
	rclcpp
	rclcpp_components
	pluginlib
{% if lifecycle is defined and lifecycle %}
	rclcpp_lifecycle
{% endif %}
	{% for dependency in dependencies %}
	{{ dependency }}
	{% endfor %})

rclcpp_components_register_node(
	${PROJECT_NAME}_component
	PLUGIN "${PROJECT_NAME}::node"
	EXECUTABLE ${PROJECT_NAME}
)

ament_export_targets(export_${PROJECT_NAME}_component)
install(
	TARGETS ${PROJECT_NAME}_component
	EXPORT export_${PROJECT_NAME}_component
	ARCHIVE DESTINATION lib
	LIBRARY DESTINATION lib
	RUNTIME DESTINATION lib
)

# Install include dir
install(
	DIRECTORY include/
	DESTINATION include
)

ament_export_include_directories(include)

##### PLUGIN Build and Install (default_plugin) ####

pluginlib_export_plugin_description_file({{ project.name }} plugins.xml)

add_library({{ project.name }}_default_plugin src/default_plugin.cpp)

# Require C99 and C++17
target_compile_features({{ project.name }}_default_plugin PUBLIC c_std_99 cxx_std_17)
target_include_directories({{ project.name }}_default_plugin PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
ament_target_dependencies(
	{{ project.name }}_default_plugin
	rclcpp
	pluginlib
	{% for dependency in dependencies %}
	{{ dependency }}
	{% endfor %}
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(
	{{ project.name }}_default_plugin
	PRIVATE "{{ project.name }}_default_plugin_BUILDING_LIBRARY"
)

install(
  TARGETS {{ project.name }}_default_plugin
  EXPORT export_{{ project.name }}_default_plugin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

ament_export_libraries({{ project.name }}_default_plugin)
ament_export_targets(export_{{ project.name }}_default_plugin)

ament_package()